using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;

using CustomObjectDataBinding.Entities;

namespace CustomObjectDataBinding
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl ggc;
		private System.Windows.Forms.TextBox txtCustomer;
		private System.Windows.Forms.Label lblCustomer;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			ggc.DataSource = DataStore.GetContractList();
			GridColumnDescriptor customerColumn = ggc.TableDescriptor.Columns["Customer"];
			customerColumn.Appearance.AnyRecordFieldCell.CellType = "ComboBox";
			customerColumn.Appearance.AnyRecordFieldCell.DataSource = DataStore.GetCustomerList();

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor gridColumnDescriptor1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor();
			this.ggc = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			this.txtCustomer = new System.Windows.Forms.TextBox();
			this.lblCustomer = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.ggc)).BeginInit();
			this.SuspendLayout();
			// 
			// ggc
			// 
			this.ggc.BackColor = System.Drawing.SystemColors.Window;
			this.ggc.Location = new System.Drawing.Point(16, 16);
			this.ggc.Name = "ggc";
			this.ggc.Size = new System.Drawing.Size(504, 400);
			this.ggc.TabIndex = 0;
			gridColumnDescriptor1.Appearance.AnyRecordFieldCell.DisplayMember = "FullName";
			gridColumnDescriptor1.MappingName = "Customer";
			gridColumnDescriptor1.Width = 200;
			this.ggc.TableDescriptor.Columns.AddRange(new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor[] {
																															new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("ID"),
																															new Syncfusion.Windows.Forms.Grid.Grouping.GridColumnDescriptor("Title"),
																															gridColumnDescriptor1});
			this.ggc.Text = "gridGroupingControl1";
			this.ggc.VersionInfo = "4.111.0.50";
			this.ggc.TableControlCurrentCellChanged += new Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventHandler(this.ggc_TableControlCurrentCellChanged);
			// 
			// txtCustomer
			// 
			this.txtCustomer.Location = new System.Drawing.Point(88, 424);
			this.txtCustomer.Name = "txtCustomer";
			this.txtCustomer.Size = new System.Drawing.Size(216, 20);
			this.txtCustomer.TabIndex = 1;
			this.txtCustomer.Text = "";
			// 
			// lblCustomer
			// 
			this.lblCustomer.Location = new System.Drawing.Point(16, 424);
			this.lblCustomer.Name = "lblCustomer";
			this.lblCustomer.Size = new System.Drawing.Size(64, 23);
			this.lblCustomer.TabIndex = 2;
			this.lblCustomer.Text = "Customer :";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(528, 454);
			this.Controls.Add(this.lblCustomer);
			this.Controls.Add(this.txtCustomer);
			this.Controls.Add(this.ggc);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.ggc)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void ggc_TableControlCurrentCellChanged(object sender, Syncfusion.Windows.Forms.Grid.Grouping.GridTableControlEventArgs e)
		{
			GridTableControl gtc = e.TableControl;
			GridCurrentCell gcc = gtc.CurrentCell;
			GridCellRendererBase cr = gtc.CurrentCell.Renderer;

			if ("Customer" == gtc.TableDescriptor.Columns[gcc.ColIndex-1].Name)
			{
				Customer cust = cr.ControlValue as Customer;
				txtCustomer.Text = cust.FullName;
			}
		}

	}
}